/*
 *   Jagmatch
 *        by Sebastian Mihai, 2015
 *        http://sebastianmihai.com
 * 
 *  A memory tile-matching game which tests the
 *  player familiarity with Atari consoles and
 *  computers.
 */

#include <stdlib.h>
#include <joypad.h>
#include "utilities.h"
#include "board.h"

extern phrase background;
extern phrase pressstart;
extern phrase author;

int main () {
    
	game_init();
	input_init();
	
	sprite* pressStartSprite = game_makeSprite( 128, 128, &pressstart );
	pressStartSprite->x = 160;
	pressStartSprite->y = 120;
	
	while( 1 ) {
		rand();
		input_read();
		if( input_isTapped( JOYPAD_OPTION ) ) {
			break;
		}
		vsync();
	};
	pressStartSprite->invisible = 1;
	
	board_init();
	
	sprite* authorSprite = game_makeSprite( 64, 32, &author );
	authorSprite->x = 280;
	authorSprite->y = 40;
	
	sprite* backgroundSprite = game_makeSprite( 320, 240, &background);
	backgroundSprite->scaled = 0;

	while ( 1 ) {
		input_read();

		if( input_isTapped( JOYPAD_UP ) ) {
			board_cursorAction( UP );
		} else if( input_isTapped( JOYPAD_DOWN ) ) {
			board_cursorAction( DOWN );
		}
		
		if( input_isTapped( JOYPAD_LEFT ) ) {
			board_cursorAction( LEFT );
		} else if( input_isTapped( JOYPAD_RIGHT ) ) {
			board_cursorAction( RIGHT );
		}
		
		if( input_isTapped( JOYPAD_A ) ) {
			board_cursorAction( FIRE );
		}
		
		board_frame();
		fprintf( game_getConsole(), "\nMoves: %03d", board_getMovesCount() );

		vsync();
	}

	return 0;
}
